/**
 Trivial pthreads program, with an ERROR:
  global variable "total_count" is modified by both threads.
 This program still has a good chance of working, but it's wrong!
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

/* Describes a range of numbers to count */
struct number_range {
	int lo, hi;
};

int total_count=0;

int count_range(number_range *n) {
	int count=0;
	for (int i=n->lo;i<n->hi;i++) 
		if ((i%2)==0)
			count++; /* i is even-- add it to the count */
	printf("%d evens between %d and %d\n",count,n->lo,n->hi);
	return count;
}

void *count_thread(void *ptr) {
	number_range *n=(number_range *)ptr;
	total_count+=count_range(n);
}

int main() {
	number_range An;
	number_range Bn;
	An.lo=0;
	An.hi=Bn.lo=500000;
	Bn.hi=1000000;
	
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_t A;
	pthread_create(&A,&attr,count_thread,&An);
	total_count+=count_range(&Bn);
	pthread_join(A,0);
	printf("Total count: %d\n",total_count);
	return 0;
}
